// components/activity/activity.js
const {
  urlParse
} = require('../../utils/util.js');

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    className: String,
    adList: Array
  },

  /**
   * 组件的初始数据
   */
  data: {
    _adList: null,
    autoplay: true,
    interval: 5000,
    selectIndex: 0
  },

  lifetimes: {
    attached: function () {
      this.setData({
        _adList: this.properties.adList.map(item => {
          const {
            query,
            url
          } = urlParse(item.appUrl)
          item.url = url || ''
          item.query = query || {}
          return item
        })
      })
    }
  },
  methods: {
    onSlideChangeEnd: function (e) {
      if (this.properties.adList.length > 1) {
        this.setData({
          selectIndex: e.detail.current
        })
      } else {
        return false
      }
    }
  }


})