// components/navbar/index.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {

  },

  /**
   * 组件的初始数据 单位为px
   */
  data: {
    top: 26,
    width: 0,
    height: 84,
    bottom: 8,
    marginLeft: 10
  },

  lifetimes: {
    attached: function () {
      this.clacNavBarHeight()
    }
  },

  attached: function () {
    this.clacNavBarHeight()
  },

  /**
   * 组件的方法列表
   */
  methods: {
    clacNavBarHeight: function () {
      // 获取菜单按钮（右上角胶囊按钮）的布局位置信息。坐标信息以屏幕左上角为原点。
      // left安全距离 - marginLeft = width左侧宽度
      // bottom 底部padding高度
      const { top, left, height } = wx.getMenuButtonBoundingClientRect()
      const bottom = this.data.bottom
      const marginLeft = this.data.marginLeft
      const navbarHeight = top + height + bottom
      const navbarWidth = left - marginLeft
      this.setData({ top, width: navbarWidth, height })
      // navbarHeight, contentHeight
      this.triggerEvent('navbarLoad', [navbarHeight, height])
    }
  }
})
