// components/home/home.js
const util = require('../../utils/util.js');

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    list: {
      type: Array,
      value: null
    },
    citySelectObj: {
      type: Object,
      value: null
    },
    isLoading: {
      type: Boolean,
      value: false
    },
    isHideTop: {
      type: Boolean,
      value: true
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    index: 0
  },

  /**
   * 组件的方法列表
   */
  methods: {
    tapSearchAction: function () {
      wx.navigateTo({
        url: '/pages/search/search'
      });
    },

    // 查看房源
    tapHouseAction: function (e) {
      let {
        currentItem
      } = e.currentTarget.dataset;
      if (currentItem.dataType == 1) {
        wx.navigateTo({
          url: `/pages/houseDetail/houseDetail?code=${currentItem.code}`
        });
      } else {
        wx.navigateTo({
          url: `/pages/roomDetail/roomDetail?code=${currentItem.code}`
        });
      }
    },

    // 查看更多房源
    tapHouseMoreAction: function (e) {
      const {
        url
      } = e.currentTarget.dataset;
      const {
        query
      } = util.urlParse(url)
      wx.navigateTo({
        url: `/pages/houseList/houseList?contentType=${query.type}&form=index`
      });
    },

    // 查看海外攻略
    tapOverseasAction: function (e) {
      let {
        currentItem
      } = e.currentTarget.dataset;
      if (currentItem.video == 2) {
        const {
          url
        } = util.urlParse(currentItem.appUrl)
        wx.navigateTo({
          url: url
        });
      } else if (currentItem.video == 1 && currentItem.id) {
        wx.navigateTo({
          url: `/pages/video/video?id=${currentItem.id}`
        })
      }
    },

    // 查看更多海外攻略
    tapOverseasMoreAction: function () {
      wx.navigateTo({
        url: `/pages/moreOverseas/moreOverseas`
      });
    },


    // 页面滑动到顶部
    pageScrollTo() {
      this.triggerEvent('scrollTo');
    }
  }
})