const util = require('../../utils/util.js');
const net = require('../../utils/net.js');
const app = getApp();
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    userInfo: {
      type: Object,
      value: null
    },
    /*用户登录的用户信息，不为空则说明已登录*/
    wxUserInfo: {
      type: Object,
      value: null
    },
    /*微信授权用户信息，不为空则说明授权过*/
    adList: Array
  },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods: {
    tapLoginAction: function () {
      app.globalData.loginSuccessNextUrl = "/pages/index/index"; //用于登录成功刷新界面
      wx.navigateTo({
        url: '/pages/login/login'
      });
    },

    tapApplyAction: function () {
      if (this.data.userInfo) {
        wx.navigateTo({
          url: '/pages/apply/apply'
        });
      } else {
        this.tapLoginAction();
      }
    },

    tapCollectAction: function () {
      if (this.data.userInfo) {
        wx.navigateTo({
          url: '/pages/collect/collect'
        });
      } else {
        this.tapLoginAction();
      }
    },
    tapInviteAction: function () {
      wx.navigateTo({
        url: '/pages/inviteFriends/inviteFriends'
      });
    },

    tapMyInviteAction: function () {
      if (this.data.userInfo) {
        wx.navigateTo({
          url: '/pages/invite/invite'
        });
      } else {
        this.tapLoginAction();
      }
    },

    outLoginAction: function () {
      util.showModal({
        title: '',
        content: '确定退出登录？',
        confirmText: '确定',
        success: function (res) {
          if (res.confirm) {
            wx.clearStorageSync();
            wx.reLaunch({
              url: '/pages/index/index'
            });
          }
        }
      });
    }
  }
})