// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const net = require('../../utils/net.js');
const util = require('../../utils/util.js');
const {
  api_house_room_list,
} = require('../../utils/api.js');

Page({

  /**
   * 页面的初始数据
   */
  data: {
    houseId: null,
    isLoading: true,
    houseData: null,
    houseList: null,
    selectRoomIndex: 0,
    userInfo: null,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options && options.houseId) {
      this.data.houseId = options.houseId;
      this.data.selectRoomIndex = options.roomIndex
      this.getAllHouselist();
    }
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    this.getAllHouselist();
  },


  getAllHouselist: function () {
    const params = {};
    params.url = api_house_room_list;
    const {
      houseId,
      selectRoomIndex,
    } = this.data
    params.data = {
      buildingId: Number(houseId),
    };
    net.req(params, true).then((data) => {
      if (data && Array.isArray(data) && data.length) {

        this.setData({
          houseData: data,
          houseList: data[selectRoomIndex].list,
          selectRoomIndex: selectRoomIndex
        });
      }
      this.setData({
        isLoading: false,
      });
    }, (e) => {
      this.setData({
        isLoading: false,
      });
    });
  },

  // 切换房间类型数据
  tapHouseTypeAction(e) {
    const {
      currentIndex
    } = e.currentTarget.dataset
    const {
      houseData
    } = this.data
    this.setData({
      houseList: houseData[currentIndex].list,
      selectRoomIndex: currentIndex
    })
  }




})