// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const {
  api_apply_list
} = require('../../utils/api.js');
const util = require('../../utils/util.js');
const net = require('../../utils/net.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isLoading: true,
    list: null,
    limit: 8,
    page: 1
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.loadWithData();
  },



  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    this.data.page += 1;
    this.loadWithData();
  },

  loadWithData: function () {
    let params = {};
    params.url = api_apply_list;
    params.data = {
      limit: this.data.limit,
      page: this.data.page
    };
    net.req(params, true).then((data) => {
      let list = this.data.list || new Array();
      this.setData({
        isLoading: false,
        list: list.concat(data.list)
      });

    }, (e) => {
      this.setData({
        isLoading: false,
        list: null
      });
    });
  },

  tapItemAction: function (e) {
    const {
      currentIndex
    } = e.currentTarget.dataset;
    const obj = this.data.list[currentIndex];
    wx.navigateTo({
      url: '/pages/applyDetail/applyDetail?id=' + obj.id
    });
  }
})