// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const {
  api_apply_info
} = require('../../utils/api.js');
const util = require('../../utils/util.js');
const net = require('../../utils/net.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isLoading: true,
    id: null,
    obj: null
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options && options.id) {
      this.data.id = options.id;
      this.loadWithData();
    }
  },

  loadWithData: function () {
    let params = {};
    params.url = api_apply_info;
    params.data = {
      id: this.data.id
    };
    net.req(params, true).then((data) => {
      this.setData({
        isLoading: false,
        obj: data
      });

    }, (e) => {
      this.setData({
        isLoading: false,
        list: null
      });
    });
  },
  setClipboardData: function () {
    const applyCode = this.data.obj.applyCode;
    wx.setClipboardData({
      data: applyCode,
      success(res) {}
    })
  },
  copWXAction: function () {
    const wechatId = this.data.obj.agentInfo.wechatId;
    wx.setClipboardData({
      data: wechatId,
      success(res) {}
    })
  },
  dialTelAction: function () {
    let {
      mobile
    } = this.data.obj.agentInfo;
    let systemInfo = util.getStorageSync('systemInfo');
    if (!systemInfo) {
      systemInfo = wx.getSystemInfoSync();
      if (systemInfo) {
        wx.setStorageSync('systemInfo', systemInfo);
      }
    }
    let {
      system
    } = systemInfo;
    if (system.toLowerCase().indexOf('ios') !== -1) {
      wx.makePhoneCall({
        phoneNumber: mobile
      });
    } else {
      wx.showActionSheet({
        itemList: [mobile],
        success(res) {
          if (res.tapIndex === 0) {
            wx.makePhoneCall({
              phoneNumber: mobile
            });
          }
        }
      });
    }
  }
})