// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const {
  api_get_mobile_prefix,
  api_apply
} = require('../../utils/api.js');
const util = require('../../utils/util.js');
const net = require('../../utils/net.js');
const {
  mApi
} = require(`../../utils/config.js`);

Page({

  /**
   * 页面的初始数据
   */
  data: {
    prefixArr: [],
    prefixIndex: 0,
    mobilePrefixId: null,
    checkInDate: '',
    firstName: '',
    firstNameW: true,
    surnName: '',
    surnNameW: true,
    mobile: '',
    mobileW: true,
    email: '',
    wxNum: '',
    wxNumW: true,
    remark: '',
    startDate: "",
    endDate: "",
    isSelect: false,
    data: '',
    canTap: true
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options && options.data) {
      this.setData({
        data: JSON.parse(options.data)
      });
    }
    this.loadPrefix();
    const date = new Date();
    const startDate = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
    const endDate = (date.getFullYear() + 3) + '-' + (date.getMonth() + 1) + '-' + date.getDate();
    const {
      rentTime
    } = this.data.data
    this.setData({
      startDate: rentTime || startDate,
      checkInDate: ((new Date(rentTime.replace(/-/g, "\/"))) < (new Date(startDate.replace(/-/g, "\/")))) ? '随时入住' : rentTime,
      endDate: endDate
    })
    const userInfo = util.getStorageSync("userInfo");
    const user = {}
    if (userInfo.mobile) {
      user.mobile = userInfo.mobile
      user.mobileW = false
    }
    if (userInfo.email) {
      user.email = userInfo.email
    }
    this.setData({
      ...user
    })
    if (userInfo.mobilePrefixId) {
      this.data.mobilePrefixId = userInfo.mobilePrefixId
    }



  },

  pickerChange: function (e) {
    this.setData({
      prefixIndex: e.detail.value
    });
  },

  loadPrefix: function () {
    let params = {};
    params.data = {
      range: 'B',
      prefix: '1'
    }
    params.url = api_get_mobile_prefix;
    net.req(params).then((res) => {
      if (res && Array.isArray(res) && res.length > 0) {
        let prefixArr = [];
        res.forEach((vvv, iii, aaa) => {
          let {
            list
          } = vvv;
          prefixArr = prefixArr.concat(list);
        });
        this.setData({
          isLoading: false,
          prefixArr: prefixArr
        }, () => {
          for (let i = 0; i < prefixArr.length; i++) {
            let tmp = prefixArr[i];
            if (this.data.mobilePrefixId) {
              if (this.data.mobilePrefixId == tmp.id) {
                this.setData({
                  prefixIndex: i
                });
                break;
              }
            } else {
              if (["86", "086", "+86", "+086"].indexOf(tmp.code) !== -1) {
                this.setData({
                  prefixIndex: i
                });
                break;
              }
            }
          }
        });
      }
    });
  },

  timePickerChange: function (e) {
    this.setData({
      checkInDate: e.detail.value
    })
  },

  bindinput: function (e) {
    let {
      currentTag,
      check
    } = e.currentTarget.dataset;
    const value = e.detail.value;
    if (util.validator.checkEmoji(value)) {
      util.showToast("输入内容含有特殊字符");
      this.setData({
        [`${currentTag}`]: value.replace(/\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g, "")
      })
    } else {
      this.data[currentTag] = value
      if (check) {
        const data = {}
        data[`${currentTag}W`] = !value.trim().length
        this.setData(data)
      }
    }


  },

  checkUpParams: function () {
    const {
      mobile,
      surnName,
      firstName,
      wxNum,
      isSelect
    } = this.data;
    if (util.validator.checkMobile(mobile) && surnName.length && firstName.length && wxNum.length) {
      if (isSelect) {
        return true
      } else {
        util.showToast("请阅读并同意《服务协议》");
      }
      return false
    }
    return false
  },

  // 服务协议 勾选操作
  tapProtocolAction() {
    const {
      isSelect
    } = this.data
    this.setData({
      isSelect: !isSelect
    })
  },

  // 查看服务协议 /pages/hooli/service-agreement.html
  tapLookProtocol() {
    wx.navigateTo({
      url: '/pages/webView/webView?webUrl=' + encodeURIComponent(`${mApi()}/pages/hooli/service-agreement.html`)
    });
  },

  sureBtnAction: function () {
    if (this.judgeWithParams() && this.data.canTap) {
      const {
        mobile,
        surnName,
        firstName,
        email,
        wxNum,
        checkInDate,
        remark,
        prefixIndex,
        prefixArr,
        data
      } = this.data;
      util.showLoading({
        title: "努力提交中..."
      });
      this.data.canTap = false; // 不能连续点击
      const tmp = prefixArr[prefixIndex];
      const that = this;
      let params = {};
      params.url = api_apply;
      params.data = {
        firstName: firstName,
        lastName: surnName,
        mobilePrefix: tmp.code,
        mobile: mobile,
        wechatId: wxNum,
        mobileCountryId: tmp.id,
        oneEc: 'miniP',
        twoEc: 'miniP_rentals',
        oneSc: 'nature',
        twoSc: 'nature_search'
      };

      if (checkInDate && checkInDate.length) {
        params.data.liveTime = checkInDate;
      }
      if (remark && remark.length) {
        params.data.extRemarks = remark;
      }
      if (email && email.length) {
        params.data.email = email;
      }
      params.data = Object.assign({}, params.data, data)
      const shareUid = util.getStorageSync('shareUid');
      if (shareUid && shareUid.length) { // 分享用户id
        params.data.shareUid = shareUid;
      }
      const shareCrmUid = util.getStorageSync('shareCrmUid');
      if (shareCrmUid && shareCrmUid.length) { // 分享管理端id
        params.data.shareCrmUid = shareCrmUid;
      }

      net.req(params, true).then((data) => {
        util.hideLoading();
        wx.navigateTo({
          url: '/pages/applySucceed/applySucceed'
        });
        that.data.canTap = true;
      }, (e) => {
        that.data.canTap = true;
        util.hideLoading();
        util.showToast(e.msg);
      });
    }
  },
  judgeWithParams: function () {
    const {
      mobile,
      isSelect,
      surnName,
      firstName,
      wxNum,
      email
    } = this.data;
    if (!util.validator.checkMobile(mobile)) {
      util.showToast("请输入正确手机号");
      return false;
    }

    if (!firstName.length) {
      util.showToast("请输入您的姓");
      return false;
    }

    if (!surnName.length) {
      util.showToast("请输入您的名");
      return false;
    }

    if (wxNum.length < 4) {
      util.showToast("请正确输入您的微信号，以便我们与您联系");
      return false;
    }

    if (email.length > 0 && !util.validator.checkEmail(email)) {
      util.showToast("请输入正确邮箱地址");
      return false;
    }

    if (!isSelect) {
      util.showToast("请阅读并同意《服务协议》");
      return false;
    }

    return true;
  }

})