// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const net = require('../../utils/net.js');
const {
  api_video_hit
} = require('../../utils/api.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    data: null,
    type: null,
    videoSrc: null,
    poster: null,
    webUrl: null,
    isShowVideo: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options && options.data) {
      const data = JSON.parse(decodeURIComponent(options.data));
      this.setData({
        data: data,
        type: options.type
      })

      wx.setNavigationBarTitle({
        title: options.type == "VR" ? "VR" : "视频"
      })
    }
  },


  tapVideoAction: function (e) {
    const {
      currentItem
    } = e.currentTarget.dataset
    if (this.data.type == "VR") {
      wx.navigateTo({
        url: `/pages/webView/webView?webUrl=${encodeURIComponent(currentItem.videoUrl)}&name=VR`
      });
    } else {
      // this.hitVideoSee(currentItem.id);
      this.setData({
        videoSrc: currentItem.videoUrl,
        poster: currentItem.imageUrl,
        isShowVideo: true
      })
    }

  },

  hitVideoSee: function (videoId) {
    let params = {};
    params.url = api_video_hit;
    params.data = {
      id: videoId
    };
    net.req(params, true).then((data) => {}, (e) => {});
  },

  hiddenVideoToast: function () {
    this.setData({
      videoSrc: null,
      poster: null,
      isShowVideo: false
    })
  },
})