// pages/invite/invite.js
// const Page = require('../../utils/ald-stat.js').Page;
const net = require('../../utils/net.js');
const {
  api_invitation_list
} = require('../../utils/api.js');

Page({

  /**
   * 页面的初始数据
   */
  data: {
    isLoading: true,
    listQuery: {
      page: 1,
      pageSize: 10
    },
    inviteList: [],
    hasMoreData: false // 暂无分页
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.loadData();
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  loadData: function () {
    // const { listQuery, inviteList } = this.data
    net.req({
      url: api_invitation_list,
      // data: { ...listQuery }
    }).then((result) => {
      this.setData({
        inviteList: result.list || []
        // inviteList: listQuery.page > 1 ? inviteList.concat(result.list) : result.list || [],
        // hasMoreData: result.totalCount > listQuery.page * listQuery.pageSize
      });
    }).catch((err) => {
      // 获取下一页错误时，页面重置到上一页，等待下次触底事件
      this.data.listQuery.page = listQuery.page - 1 || 1
    }).finally(() => {
      if (this.data.isLoading) {
        this.setData({
          isLoading: false
        })
      }
    })
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.data.listQuery.page = 1;
    this.loadData();
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if (this.data.hasMoreData) {
      this.data.listQuery.page += 1;
      this.loadData();
    }
  },

  tapShare: function () {
    wx.navigateTo({
      url: '/pages/inviteFriends/inviteFriends'
    })
  }
})