// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const net = require('../../utils/net.js');
const util = require('../../utils/util.js');
import Poster from '../../utils/poster.js'
const {
  api_invite_shareInfo
} = require('../../utils/api.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userInfo: null,
    mobile: '',
    posterArr: null,
    template: null,
    isShowQRPoster: true,
    isShowCanvas: false,
    extendObj: null,
    wxFriendsShare: null,
    isLogin: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const userInfo = util.getStorageSync('userInfo');
    if (userInfo && userInfo.token) {
      this.data.userInfo = userInfo
      this.data.mobile = userInfo.mobile.replace(/(\d{3})\d*(\d{4})/, '$1****$2')
      this.getBarcode(1);
      this.getBarcode(0);
      this.setData({
        isLogin: true
      })
    }
  },

  // 登录成功回调
  loginCallback() {
    const userInfo = util.getStorageSync('userInfo');
    if (userInfo && userInfo.token) {
      this.getBarcode(1);
      this.getBarcode(0);
      this.setData({
        isLogin: true
      })
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    const {
      image,
      content,
      page,
      title
    } = this.data.wxFriendsShare
    return {
      title: title,
      path: page,
      imageUrl: image || "https://static.hoolihome.com/jfiles/activity/invite/3x/wxshare.png",
      desc: content || "房子不错,服务也好,诚意推荐给你,海外好生活就要一起分享"
    }
  },
  getBarcode: function (ignoreMiniCode) {
    const params = {};
    params.url = api_invite_shareInfo;
    params.data = {
      hooid: "hoolihome",
      width: 150,
      ignoreMiniCode: ignoreMiniCode
    };
    net.req(params).then((res) => {
      if (parseInt(ignoreMiniCode) == 1) {
        this.setData({
          wxFriendsShare: res.wxFriendsShare,
          isShowQRPoster: true
        });

      } else {
        this.setData({
          extendObj: res.shareImgs,
          isShowQRPoster: true
        });
      }
    });
  },

  posterCallack: function (arr) {
    if (!arr) return;
    arr.forEach((v, i, a) => {
      let {
        id,
        dataset
      } = v;
      if (id.indexOf('img') !== -1) {
        wx.getImageInfo({
          src: dataset.what,
          success: (res) => {
            v.dataset.uri = res.path;
          }
        });
      }
    });
    this.data.posterArr = arr
  },
  onImgOK: function (e) {
    const canvasSrc = e.detail.path;
    wx.hideLoading();
    this.setData({
      isShowCanvas: false
    }, () => {
      this.setData({
        shareQRImgSrc: canvasSrc
      })
      wx.previewImage({
        current: canvasSrc, // 当前显示图片的http链接
        urls: [canvasSrc] // 需要预览的图片http链接列表
      })
    });
  },

  handleGeneratePoster: function () {
    const _this = this;
    const {
      extendObj,
      shareQRImgSrc,
      posterArr
    } = this.data
    if (extendObj) {
      if (shareQRImgSrc) {
        wx.previewImage({
          current: shareQRImgSrc, // 当前显示图片的http链接
          urls: [shareQRImgSrc] // 需要预览的图片http链接列表
        })
        return;
      }
      _this.setData({
        isShowCanvas: true,
        isShowQRPoster: false
      }, () => {
        let palette = new Poster().palette(posterArr);
        this.setData({
          template: palette
        });
        wx.showLoading({
          title: '生成海报中...'
        });
      });
    } else {
      util.showToast("海报分享优化中,请使用微信小程序自带分享...", null, true);
    }
  },

  tapToLogin() {
    wx.navigateTo({
      url: '/pages/login/login'
    });
  }
})