// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const net = require('../../utils/net.js');
const util = require('../../utils/util.js');
const {
  api_wx_login
} = require('../../utils/api.js');

const app = getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {
    canIUse: wx.canIUse('button.open-type.getPhoneNumber'),
    tel: '400-898-6659'
  },
  pageData: {
    wxCode: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.login({
      success: (res) => {
        this.pageData.wxCode = res.code;
      }
    });
  },

  onHide: function () {},

  tapPhoneLoginAction: function () {
    wx.navigateTo({
      url: '/pages/register/register'
    });
  },

  getPhoneNumber: function (e) {
    let {
      encryptedData,
      iv
    } = e.detail;
    if (!encryptedData || !iv) {
      return false;
    }
    let goNext = () => {
      wx.login({
        success: (res) => {
          let {
            code
          } = res;
          if (!code) {
            return false;
          }
          this.wxLogin(code, encryptedData, iv)
        }
      })
    };
    wx.checkSession({
      success: () => {
        if (this.pageData.wxCode) {
          this.wxLogin(this.pageData.wxCode, encryptedData, iv);
        } else {
          goNext();
        }
      },
      fail: () => {
        goNext();
      }
    });
  },
  wxLogin(code, encryptedData, iv) {
    let params = {};
    params.url = api_wx_login;
    params.data = {
      code,
      encryptedData,
      iv,
      hooid: 'hoolihome',
      oneEc: 'miniP',
      twoEc: 'miniP_rentals',
      oneSc: 'nature',
      twoSc: 'nature_search'
    };
    wx.showLoading({
      title: '努力登录中...',
    })
    const shareUid = util.getStorageSync('shareUid');
    if (shareUid && shareUid.length) { // 分享用户id
      params.data.shareUid = shareUid;
    }
    const shareCrmUid = util.getStorageSync('shareCrmUid');
    if (shareCrmUid && shareCrmUid.length) { // 分享管理端id
      params.data.shareCrmUid = shareCrmUid;
    }
    net.req(params, true).then((data) => {
      wx.hideLoading()
      if (data && data.userInfo && data.userInfo.token) {
        util.setStorageSync('userInfo', data.userInfo);
        let {
          loginSuccessNextUrl
        } = app.globalData;
        if (loginSuccessNextUrl && loginSuccessNextUrl.length) {
          app.globalData.loginSuccessNextUrl = '';
          loginSuccessNextUrl = decodeURIComponent(loginSuccessNextUrl);
          wx.reLaunch({
            url: loginSuccessNextUrl
          });
        } else {
          let pages = getCurrentPages(); /*在内存中的所有页面栈对象*/
          let prePage = pages[pages.length - 2]; /*我的页面对象*/
          if (prePage) {
            if (prePage.loginCallback) prePage.loginCallback();
            wx.navigateBack();
          } else {
            wx.navigateBack();
          }
        }
        return false;
      }
      util.showModal({
        title: '提示',
        content: `抱歉，您暂无登录权限，合作请咨询${this.data.tel}`,
        showCancel: false
      });
    }, (e) => {
      wx.hideLoading()
      util.showModal({
        title: '提示',
        content: (e && e.msg) || `抱歉，您暂无登录权限，合作请咨询${this.data.tel}`,
        showCancel: false
      });
    });
  },
})