const {
  api_school_list
} = require("../../utils/api.js");
const util = require("../../utils/util.js");
const net = require("../../utils/net.js");
Page({
  /**
   * 页面的初始数据
   */
  data: {
    isLoading: false,
    countryId: 0,
    cityId: 0,
    listData: [],
    isShowBtn: false,
    schoolName: "",
    hidEmpty: true
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options && options.cityId && options.countryId) {
      this.data.cityId = options.cityId;
      this.data.countryId = options.countryId;
    }
    if (options && options.schoolName) {
      this.data.schoolName = options.schoolName;
    }
    this._getWithData(this.data.schoolName);
  },

  _getWithData: function (keywords) {
    const {
      cityId,
      countryId
    } = this.data;
    let params = {};
    params.data = {
      cityId: cityId,
      countryId: countryId
    };
    if (keywords && keywords.length) {
      params.data.name = keywords;
    }
    params.url = api_school_list;
    net.req(params, true).then(
      data => {
        if (data && Array.isArray(data.list) && data.list.length) {
          this.dealWithData(data.list, keywords)
        } else {
          this.setData({
            listData: [],
            isShowBtn: true,
            hidEmpty: false
          });
        }
      },
      e => {
        this.setData({
          isLoading: false
        });
      }
    );
  },

  dealWithData: function (arr, keywords) {
    if (!arr || !Array.isArray(arr) || arr.length === 0) {
      return false
    }
    const s = `<b style="color:#FF523D;font-size:15px">${keywords}</b>`;
    const reg = new RegExp(keywords, 'gi')
    arr.forEach((val, i) => {
      let {
        name
      } = val;
      if (name) {
        val.sname = name.replace(reg, s)
      }
    })
    this.setData({
      isLoading: false,
      hidEmpty: true,
      listData: arr
    });
  },

  _tapSchoolAction: function (e) {
    const {
      currentItem
    } = e.currentTarget.dataset
    this.callBackBlock({
      schoolId: currentItem.id,
      schoolName: currentItem.name
    });
  },

  _inputChange: function (event) {
    const value = event.detail.value.trim();
    this._getWithData(value);
    this.data.schoolName = value
  },

  tapSureAction() {
    this.callBackBlock({
      schoolName: this.data.schoolName
    });
  },

  callBackBlock: function (currentItem) {
    let pages = getCurrentPages(); /*在内存中的所有页面栈对象*/
    let prePage = pages[pages.length - 2]; /*我的页面对象*/
    if (prePage) {
      if (prePage.blockCallBack) prePage.blockCallBack(currentItem);
      wx.navigateBack();
    } else {
      wx.navigateBack();
    }
  }
});