// 请注意常量的命名必须是Page
const Page = require('../../utils/ald-stat.js').Page;
const {
  api_get_video_detail
} = require('../../utils/api.js');
const util = require('../../utils/util.js');
const net = require('../../utils/net.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    videoId: null,
    videoData: null,
    showHomeBtn: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let {
      id,
      shareUid,
      shareCrmUid
    } = options;

    if (shareUid && shareUid.length) { // 分享用户id
      util.setStorageSync('shareUid', shareUid);
    }
    if (shareCrmUid && shareCrmUid.length) { // 分享管理端id
      util.setStorageSync('shareCrmUid', shareCrmUid);
    }

    const pages = getCurrentPages();
    if (pages.length == 1) {
      this.setData({
        showHomeBtn: true
      })
    }

    if (id) {
      this.data.videoId = id;
      this.loadVideoData(id);
    } else {
      util.showToast("视频地址错误，请您稍后再试");
      if (pages.length == 1) {
        wx.reLaunch({
          url: '/pages/index/index'
        });
      } else {
        wx.navigateBack();
      }
    }

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    let path = `/pages/video/video?id=${this.data.videoId}`;
    const userInfo = util.getStorageSync('userInfo');
    if (userInfo && userInfo.userCode && userInfo.userCode.length) { // 分享用户id
      path = path + `&shareUid=${userInfo.userCode}`
    }
    return {
      title: this.data.videoData.title,
      path: path,
      imageUrl: this.data.videoData.coverImg
    }
  },

  loadVideoData(videoId) {
    let params = {};
    params.url = api_get_video_detail;
    params.data = {
      id: videoId
    };
    net.req(params, true).then((data) => {
      wx.setNavigationBarTitle({
        title: data.title
      })
      this.setData({
        videoData: data
      })
    }, (e) => {
      util.showToast(JSON.stringify(e));
    });
  },
  goHomeAction: function () {
    wx.reLaunch({
      url: '/pages/index/index'
    });
  },
})