export default class Poster {

  palette(posterArr) {
    if (posterArr && Array.isArray) {
      let firstTagBgTop = 0;
      let firstTagBgHeight = 0;
      let number = 1;
      let marginBottom = 8;
      let canCanvasTag = true;
      let canvasObj = {
        views: []
      };
      const pixelRatio = wx.getSystemInfoSync().pixelRatio
      posterArr.forEach((val, i, arr) => {
        let {
          id,
          left,
          top,
          width,
          height,
          color,
          backgroundColor,
          fontSize,
          fontWeight,
          borderRadius,
          dataset
        } = val;

        fontSize = fontSize.replace('px', '')
        fontSize = Math.ceil(Number(fontSize) * pixelRatio) + 'px';
        top = Math.ceil(top * pixelRatio);
        left = Math.ceil(left * pixelRatio);
        if (pixelRatio > 3) { // 曲面屏做适配
          width = Math.ceil(width * pixelRatio) + 5;
        } else {
          width = Math.ceil(width * pixelRatio);
        }
        height = Math.ceil(height * pixelRatio);
        borderRadius = borderRadius.replace('px', '');
        borderRadius = Math.ceil(Number(borderRadius) * pixelRatio) + 'px';

        let {
          what,
          uri,
          mode
        } = dataset;
        if (what) {
          what = what.toString();
        }
        switch (id) {
          case 'container':
            Object.assign(canvasObj, {
              width: `${width}px`,
              height: `${height}px`,
              background: '#ffffff',
              borderRadius: '0px'
            });
            break;
          case 'above':
            canvasObj.views.push({
              type: 'rect',
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
              },
            });
            break;
          case 'tagBg':
            if (firstTagBgTop == 0) {
              firstTagBgTop = top;
              firstTagBgHeight = height;
              canvasObj.views.push({
                type: 'rect',
                css: {
                  left: `${left}px`,
                  top: `${top}px`,
                  width: `${width}px`,
                  height: `${height}px`,
                  borderRadius: `${borderRadius}`,
                  backgroundColor: `${backgroundColor}`
                }
              });
            } else if ((top - firstTagBgTop) < firstTagBgHeight * number) {
              canvasObj.views.push({
                type: 'rect',
                css: {
                  left: `${left}px`,
                  top: `${top}px`,
                  width: `${width}px`,
                  height: `${height}px`,
                  borderRadius: `${borderRadius}`,
                  backgroundColor: `${backgroundColor}`
                }
              });
            } else {
              canCanvasTag = false
            }
            break;
          case 'imgPhoto':
            canvasObj.views.push({
              type: 'image',
              url: uri || what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                borderRadius: `${borderRadius}`
              }
            });
            break;
          case 'imgLogo':
            canvasObj.views.push({
              type: 'image',
              url: uri || what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`
              }
            });
            break;
          case 'img':
            canvasObj.views.push({
              type: 'image',
              url: uri || what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                borderRadius: `${borderRadius}`,
                mode: mode || ''
              }
            });
            break;
          case 'goodTitle':
            canvasObj.views.push({
              type: 'text',
              text: what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                color: `${color}`,
                fontSize: `${fontSize}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: `${backgroundColor}`,
              }
            });
            break;
          case 'imgBarcode':
            canvasObj.views.push({
              type: 'image',
              url: uri || what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                borderRadius: `${height}px`
              }
            });
            break;
          case 'imgHead':
            canvasObj.views.push({
              type: 'image',
              url: uri || what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                borderRadius: `${height}px`
              }
            });
            break;
          case 'tag':
            if (canCanvasTag) {
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${left}px`,
                  top: `${top + 1}px`,
                  width: `${width + 10}px`,
                  height: `${height}px`,
                  fontSize: `${fontSize}`,
                  color: `${color}`,
                  fontWeight: `${fontWeight}`,
                  backgroundColor: `${backgroundColor}`
                }
              });
            }
            break;
          case 'topWrapper':
            canvasObj.views.push({
              type: 'rect',
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                backgroundColor: `${backgroundColor}`
              }
            });
            break;
          case 'unit':
          case 'cycle': {
            canvasObj.views.push({
              type: 'text',
              text: what,
              css: {
                left: `${left}px`,
                top: `${top-2}px`,
                width: `${width + 10}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: `${backgroundColor}`
              }
            });
            break;
          }
          case 'money':
            canvasObj.views.push({
              type: 'text',
              text: what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width + 10}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: '#FFFFFF'
              }
            });
            break;
          case 'tip':
            canvasObj.views.push({
              type: 'text',
              text: what,
              css: {
                left: `${left}px`,
                top: `${top + 4}px`,
                width: `${width + 10}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: '#FFFFFF'
              }
            });
            break;
          default:
            canvasObj.views.push({
              type: 'text',
              text: what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: '#FFFFFF'
              }
            });
            break;
        }
      });
      return canvasObj;
    }
  }
}